//---------------------------------------------------------------------------
// FullGlyph.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <Moochos/Moa/Forms.h>
#include <Moochos/Moa/Hash.h>
//---------------------------------------------------------------------------
USEFORM("MainFormUnit.cpp", MainForm);
USEFORM("ProgressDialogUnit.cpp", ProgressDialog);
//---------------------------------------------------------------------------
namespace {
//---------------------------------------------------------------------------
AnsiString __fastcall GetAppInstanceLockName();
//---------------------------------------------------------------------------
AnsiString __fastcall GetAppInstanceLockName()
{
	AnsiString toHashData = AnsiUpperCaseFileName(ExtractFileDir(ParamStr(0)));
	int id = TCrc32Hasher().Update(toHashData).Value;
	return AnsiString().sprintf("FullGlyph_InstanceLock_N%08X", id);
}
//---------------------------------------------------------------------------
} // End of namespace
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	try
	{
		TAppInstanceLock lock(GetAppInstanceLockName());
		if(!lock.Locked) {
			lock.ActivateFirst();
			return 0;
		}
		Application->Initialize();
		Application->Title = "Full Glyph";
		Application->CreateForm(__classid(TMainForm), &MainForm);
		Application->CreateForm(__classid(TProgressDialog), &ProgressDialog);
		Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	catch (...)
	{
		try
		{
			throw Exception("");
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}
	return 0;
}
//---------------------------------------------------------------------------

