//---------------------------------------------------------------------------
#ifndef Moochos_FullGlyph_GlyphConvertCommand_H
#define Moochos_FullGlyph_GlyphConvertCommand_H
//---------------------------------------------------------------------------
// GlyphConvertCommand.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace FullGlyph { namespace GlyphConvertCommand {
//---------------------------------------------------------------------------
class EGlyphConvertError : public Exception
{
public:
	__fastcall EGlyphConvertError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TGlyphConvertCommand : public TObject
{
private:
	AnsiString FFile;
	TColor FLightColor;
	TColor FShadowColor;
	AnsiString FOutputDir;
	void __fastcall LoadGlyph(Graphics::TBitmap* AGlyph);
	void __fastcall EditGlyph(Graphics::TBitmap* AGlyph);
	void __fastcall SaveGlyph(Graphics::TBitmap* AGlyph);
	inline TColor __fastcall GetPixel(Graphics::TBitmap* ABitmap, int AX, int AY) const;
	inline void __fastcall SetPixel(Graphics::TBitmap* ABitmap, int AX, int AY, TColor APixel) const;
protected:
public:
	__fastcall TGlyphConvertCommand(const AnsiString& AFile, TColor ALightColor, TColor AShadowColor, const AnsiString& AOutputDir);
	virtual __fastcall ~TGlyphConvertCommand();
	void __fastcall Execute();
};
//---------------------------------------------------------------------------
}}} using namespace Moochos::FullGlyph::GlyphConvertCommand;
//---------------------------------------------------------------------------
#endif

