//---------------------------------------------------------------------------
#ifndef Moochos_FullGlyph_GlyphConvertTask_H
#define Moochos_FullGlyph_GlyphConvertTask_H
//---------------------------------------------------------------------------
// GlyphConvertTask.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Moochos/Moa/Tasks.h>
//---------------------------------------------------------------------------
namespace Moochos { namespace FullGlyph { namespace GlyphConvertTask {
//---------------------------------------------------------------------------
class EGlyphConvertTaskError : public Exception
{
public:
	__fastcall EGlyphConvertTaskError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TGlyphConvertTask : public TTask
{
public:
	typedef void __fastcall (__closure * TStatusEvent)(TObject* ASender, const AnsiString& AText);
private:
	class EUserCancel : public Exception
	{
	public:
		__fastcall EUserCancel(const AnsiString& AMessage) : Exception(AMessage) {}
	};
	class EErrorStop : public Exception
	{
	public:
		__fastcall EErrorStop(const AnsiString& AMessage) : Exception(AMessage) {}
	};
	TStrings* FFiles;
	TColor FLightColor;
	TColor FShadowColor;
	AnsiString FOutputDir;
	AnsiString FLogFile;
	TStream* FLogStream;
	int FErrorCount;
	int FWarningCount;
	TStatusEvent FOnStatus;
	void __fastcall Initialize(TStrings* AFiles);
	void __fastcall Uninitialize();
	void __fastcall MainCreateOutputDir();
	void __fastcall MainConvertGlyphs();
	void __fastcall MainEnsureNotCanceled();
	void __fastcall CreateLog();
	void __fastcall CloseLog();
	void __fastcall LogError(const AnsiString& AText);
	void __fastcall LogWarning(const AnsiString& AText);
	void __fastcall LogInfo(const AnsiString& AText);
	void __fastcall LogLine(const AnsiString& AText);
	void __fastcall ReportStatus(const AnsiString& AText);
	void __fastcall DoStatus(const AnsiString& AText);
protected:
	virtual void __fastcall Main();
public:
	__fastcall TGlyphConvertTask(TStrings* AFiles, TColor ALightColor, TColor AShadowColor, const AnsiString& AOutputDir, const AnsiString& ALogFile);
	virtual __fastcall ~TGlyphConvertTask();
	__property int ErrorCount = {read=FErrorCount, write=FErrorCount};
	__property int WarningCount = {read=FWarningCount, write=FWarningCount};
	__property TStatusEvent OnStatus = {read=FOnStatus, write=FOnStatus};
};
//---------------------------------------------------------------------------
}}} // End of Moochos:FullGlyph::GlyphConvertTask
using namespace Moochos::FullGlyph::GlyphConvertTask;
//---------------------------------------------------------------------------
#endif

