//---------------------------------------------------------------------------
#ifndef Moochos_FullGlyph_GlyphsMan_H
#define Moochos_FullGlyph_GlyphsMan_H
//---------------------------------------------------------------------------
// GlyphsMan.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
namespace Moochos { namespace FullGlyph { namespace GlyphConvertTask { class TGlyphConvertTask; }}} using namespace Moochos::FullGlyph::GlyphConvertTask;
//---------------------------------------------------------------------------
namespace Moochos { namespace FullGlyph { namespace GlyphsMan {
//---------------------------------------------------------------------------
class EGlyphsManError : public Exception
{
public:
	__fastcall EGlyphsManError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TGlyphsMan : public TObject
{
private:
	TGlyphConvertTask* FTask;
	bool FTaskCanceled;
	TOpenDialog* FFilesOpenDialog;
	TSaveDialog* FLogSaveDialog;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall EnsureAskSaveLog(TGlyphConvertTask* ATask);
	void __fastcall TaskIdle(TObject* ASender);
	void __fastcall TaskProgress(TObject* ASender);
	void __fastcall TaskStatus(TObject* ASender, const AnsiString& AText);
	void __fastcall ProgressDialogExecute(TObject* ASender);
	void __fastcall ProgressDialogCancel(TObject* ASender);
protected:
public:
	__fastcall TGlyphsMan();
	virtual __fastcall ~TGlyphsMan();
	void __fastcall ChooseFiles(TStrings* AFiles);
	void __fastcall Convert(TStrings* AFiles, TColor ALightColor, TColor AShadowColor, const AnsiString& AOutputDir);
	void __fastcall SaveLogAs();
	void __fastcall DeleteLog(bool AConfirm);
	bool __fastcall HasLog();
	__property TOpenDialog* FilesOpenDialog = {read=FFilesOpenDialog};
	__property TSaveDialog* LogSaveDialog = {read=FLogSaveDialog};
};
//---------------------------------------------------------------------------
}}} // End of Moochos::FullGlyph::GlyphsMan
using namespace Moochos::FullGlyph::GlyphsMan;
//---------------------------------------------------------------------------
#endif

