//---------------------------------------------------------------------------
// HelpMan.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "HelpMan.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace FullGlyph { namespace HelpMan {
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace {
//---------------------------------------------------------------------------
const AnsiString HelpFile = ExtractFilePath(Application->ExeName) + "Help\\index.html";
const AnsiString AboutTitle = "About";
const AnsiString AboutMessage = "Full Glyph Version 1.0.0.\r\n\r\nMoochos";
//---------------------------------------------------------------------------
} // End of namespace
//---------------------------------------------------------------------------
__fastcall THelpMan::THelpMan() :
	TObject()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall THelpMan::~THelpMan()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall THelpMan::ShowContents(bool AConfirm)
{
	if(AConfirm) {
		if(Application->MessageBox(
			AnsiString().sprintf("The program opens the file \"%s\".\r\n\r\nContinue?", HelpFile.c_str()).c_str(),
			Application->Title.c_str(),
			MB_YESNO | MB_ICONWARNING | MB_SETFOREGROUND) != IDYES) {
			return false;
		}
	}
	SHELLEXECUTEINFO info = {0};
	info.cbSize = sizeof(SHELLEXECUTEINFO);
	info.fMask = SEE_MASK_FLAG_NO_UI;
	info.hwnd = Application->Handle;
	info.lpFile = HelpFile.c_str();
	info.nShow = SW_SHOWNORMAL;
	if(!ShellExecuteEx(&info)) {
		throw EHelpManError("The program cannot open the help.");
	}
	return true;
}
//---------------------------------------------------------------------------
void __fastcall THelpMan::ShowAbout()
{
	Application->MessageBox(
		AboutMessage.c_str(),
		AboutTitle.c_str(),
		MB_OK | MB_ICONINFORMATION | MB_SETFOREGROUND);
}
//---------------------------------------------------------------------------
}}} // End of Moochos::FullGlyph::HelpMan
//---------------------------------------------------------------------------

