//---------------------------------------------------------------------------
// InputMan.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <FileCtrl.hpp>
#include "InputMan.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace FullGlyph { namespace InputMan {
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
void __fastcall TInputMan::Initialize()
{
	try {
		FColorDialog = new TColorDialog(NULL);
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TInputMan::Uninitialize()
{
	delete FColorDialog;
	FColorDialog = NULL; 
}
//---------------------------------------------------------------------------
__fastcall TInputMan::TInputMan() :
	TObject(),
	FColorDialog(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TInputMan::~TInputMan()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
TColor __fastcall TInputMan::ChooseColor(TColor AColor)
{
	ColorDialog->Color = AColor;
	if(!ColorDialog->Execute()) {
		Abort();
	}
	return ColorDialog->Color;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TInputMan::ChooseDirectory(const AnsiString& AMessage, const AnsiString& ADirectory)
{
	AnsiString directory = ADirectory;
	if(!SelectDirectory(AMessage, WideString(), directory)) {
		Abort();
	}
	SetCurrentDir(directory);
	return directory;
}
//---------------------------------------------------------------------------
}}} // End of Moochos::FullGlyph::InputMan
//---------------------------------------------------------------------------

