//---------------------------------------------------------------------------
// Forms.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Forms.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Forms {
//---------------------------------------------------------------------------
BOOL CALLBACK TAppInstanceLock::MarkProc(HWND hwnd, LPTSTR lpszString, HANDLE hData, DWORD dwData)
{
	if(lpszString == NULL) {
		return true;
	}
	else if(HIWORD(reinterpret_cast<DWORD>(lpszString)) == 0) {
		// Ignore atoms
		return true; 
	}
	else {
		return lstrcmp(lpszString, (*reinterpret_cast<AnsiString*>(dwData)).c_str()) != 0;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppInstanceLock::ActivateFirstProc(HWND AHandle, void* AData)
{
	(*static_cast<bool*>(AData)) = ::IsWindowVisible(AHandle) && ::SetForegroundWindow(AHandle);
}
//---------------------------------------------------------------------------
BOOL CALLBACK TAppInstanceLock::FindFirstProc(HWND hwnd, LPARAM lParam)
{
	TFindFirstData& data = *reinterpret_cast<TFindFirstData*>(lParam);
	if(::GetProp(hwnd, data.MarkName.c_str()) == NULL) {
		return true;
	}
	data.Proc(hwnd, data.Data);
	data.Found = true;
	return false;
}
//---------------------------------------------------------------------------
bool __fastcall TAppInstanceLock::Lock()
{
	::SetLastError(NO_ERROR);
	HANDLE handle = ::CreateMutex(NULL, true, FLockName.c_str());
	if(handle == NULL) {
		return false;
	}
	if(::GetLastError() == ERROR_ALREADY_EXISTS) {
		::CloseHandle(handle);
		return false;
	}
	else if(::GetLastError() != NO_ERROR) {
		return false;
	}
	FLockHandle = handle;
	FLocked = true;
	return true;
}
//---------------------------------------------------------------------------
void __fastcall TAppInstanceLock::Unlock()
{
	if(!FLocked) {
		return;
	}
	::CloseHandle(FLockHandle);
	FLockHandle = NULL;
	FLocked = false;
}
//---------------------------------------------------------------------------
bool __fastcall TAppInstanceLock::Mark()
{
	if(::EnumPropsEx(Application->Handle, reinterpret_cast<PROPENUMPROCEX>(MarkProc), reinterpret_cast<LPARAM>(&FMarkName)) == static_cast<int>(false)) {
		return false;
	}
	if(!::SetProp(Application->Handle, FMarkName.c_str(), reinterpret_cast<HANDLE>(1))) {
		return false;
	}
	FMarked = true;
	return true;
}
//---------------------------------------------------------------------------
void __fastcall TAppInstanceLock::Unmark()
{
	if(!FMarked) {
		return;
	}
	::RemoveProp(Application->Handle, FMarkName.c_str());
	FMarked = false;
}
//---------------------------------------------------------------------------
__fastcall TAppInstanceLock::TAppInstanceLock(const AnsiString& ALockName) :
	FLockHandle(NULL),
	FLockName(ALockName),
	FMarkName(ALockName),
	FLocked(false),
	FMarked(false)
{
	if(!Lock() || !Mark()) {
		Unmark();
		Unlock();
	}
}
//---------------------------------------------------------------------------
__fastcall TAppInstanceLock::~TAppInstanceLock()
{
	Unmark();
	Unlock();
}
//---------------------------------------------------------------------------
bool __fastcall TAppInstanceLock::ActivateFirst()
{
	bool succeeded = false;
	FindFirst(ActivateFirstProc, &succeeded);
	return succeeded;
}
//---------------------------------------------------------------------------
bool __fastcall TAppInstanceLock::FindFirst(TFindFirstProc AProc, void* AData)
{
	TFindFirstData data;
	data.MarkName = FMarkName;
	data.Proc = AProc;
	data.Data = AData;
	data.Found = false;
	::EnumWindows(reinterpret_cast<WNDENUMPROC>(FindFirstProc), reinterpret_cast<LPARAM>(&data));
	return data.Found;
}
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Forms
//---------------------------------------------------------------------------

