//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Forms_H
#define Moochos_Moa_Forms_H
//---------------------------------------------------------------------------
// Forms.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Forms {
//---------------------------------------------------------------------------
class EFormError : public Exception
{
public:
	__fastcall EFormError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TAppInstanceLock
{
public:
	typedef void __fastcall (* TFindFirstProc)(HWND AHandle, void* AData);
private:
	struct TFindFirstData
	{
		AnsiString MarkName;
		TFindFirstProc Proc;
		void* Data;
		bool Found;
	};
	HANDLE FLockHandle;
	AnsiString FLockName;
	AnsiString FMarkName;
	bool FLocked;
	bool FMarked;
	static BOOL CALLBACK MarkProc(HWND hwnd, LPTSTR lpszString, HANDLE hData, DWORD dwData);
	static void __fastcall ActivateFirstProc(HWND AHandle, void* AData);
	static BOOL CALLBACK FindFirstProc(HWND hwnd, LPARAM lParam);
	__fastcall TAppInstanceLock(const TAppInstanceLock& AOther); // Forbidden
	TAppInstanceLock& __fastcall operator =(const TAppInstanceLock& AOther); // Forbidden
	bool __fastcall Lock();
	void __fastcall Unlock();
	bool __fastcall Mark();
	void __fastcall Unmark();
protected:
public:
	__fastcall TAppInstanceLock(const AnsiString& ALockName);
	__fastcall ~TAppInstanceLock();
	bool __fastcall ActivateFirst();
	bool __fastcall FindFirst(TFindFirstProc AFindFirstProc, void* AData);
	__property bool Locked = {read=FLocked};
};
//---------------------------------------------------------------------------
}}} // End of Moochos::Moa::Forms
using namespace Moochos::Moa::Forms;
//---------------------------------------------------------------------------
#endif

