//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Hash_H
#define Moochos_Moa_Hash_H
//---------------------------------------------------------------------------
// Hash.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Hash {
//---------------------------------------------------------------------------
class EHashError : public Exception
{
public:
	__fastcall EHashError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TCrc32Hasher
{
private:
	static const unsigned int FTable[256];
	static const unsigned int FMask;
	unsigned int FCurrent;
	__fastcall TCrc32Hasher(const TCrc32Hasher& AOther); // Forbidden
	TCrc32Hasher& __fastcall operator =(const TCrc32Hasher& AOther); // Forbidden
	int __fastcall GetValue() const;
protected:
public:
	__fastcall TCrc32Hasher();
	__fastcall ~TCrc32Hasher();
	TCrc32Hasher& __fastcall Update(const AnsiString& AData);
	TCrc32Hasher& __fastcall Update(const void* AData, int ALength);
	void __fastcall Reset();
	__property int Value = {read=GetValue};
};
//---------------------------------------------------------------------------
}}} // End of Moochos::Moa::Hash
using namespace Moochos::Moa::Hash;
//---------------------------------------------------------------------------
#endif

