//---------------------------------------------------------------------------
#ifndef Moochos_Moa_IniFiles_H
#define Moochos_Moa_IniFiles_H
//---------------------------------------------------------------------------
// IniFiles.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <IniFiles.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace IniFiles {
//---------------------------------------------------------------------------
class TVarIniFile : public TMemIniFile
{
public:
	static const char DefQuoteChar = '\"';
private:
protected:
public:
	__fastcall TVarIniFile(const AnsiString& AFileName);
	virtual __fastcall ~TVarIniFile();
	virtual TRect __fastcall ReadRect(const AnsiString& ASection, const AnsiString& AIdent, const TRect& ADefault);
	virtual void __fastcall WriteRect(const AnsiString& ASection, const AnsiString& AIdent, const TRect& AValue);
	virtual TPoint __fastcall ReadPoint(const AnsiString& ASection, const AnsiString& AIdent, const TPoint& ADefault);
	virtual void __fastcall WritePoint(const AnsiString& ASection, const AnsiString& AIdent, const TPoint& AValue);
	virtual AnsiString __fastcall ReadQuotedString(const AnsiString& ASection, const AnsiString& AIdent, AnsiString ADefault, char AQuoteChar = DefQuoteChar);
	virtual void __fastcall WriteQuotedString(const AnsiString& ASection, const AnsiString& AIdent, AnsiString AValue, char AQuoteChar = DefQuoteChar);
	virtual __int64 __fastcall ReadInteger64(const AnsiString& ASection, const AnsiString& AIdent, __int64 ADefault);
	virtual void __fastcall WriteInteger64(const AnsiString& ASection, const AnsiString& AIdent, __int64 AValue);
	virtual unsigned __int64 __fastcall ReadUInteger64(const AnsiString& ASection, const AnsiString& AIdent, unsigned __int64 ADefault);
	virtual void __fastcall WriteUInteger64(const AnsiString& ASection, const AnsiString& AIdent, unsigned __int64 AValue);
	virtual unsigned int __fastcall ReadUInteger(const AnsiString& ASection, const AnsiString& AIdent, unsigned int ADefault);
	virtual void __fastcall WriteUInteger(const AnsiString& ASection, const AnsiString& AIdent, unsigned int AValue);
	virtual double __fastcall ReadDouble(const AnsiString& ASection, const AnsiString& AIdent, double ADefault);
	virtual void __fastcall WriteDouble(const AnsiString& ASection, const AnsiString& AIdent, double AValue);
};
//---------------------------------------------------------------------------
}}} // End of Moochos::Moa::IniFiles
using namespace Moochos::Moa::IniFiles;
//---------------------------------------------------------------------------
#endif

