//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Shell_H
#define Moochos_Moa_Shell_H
//---------------------------------------------------------------------------
// Shell.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Shell {
//---------------------------------------------------------------------------
class EShellError : public Exception
{
public:
	__fastcall EShellError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class EFileDropError : public EShellError
{
public:
	__fastcall EFileDropError(const AnsiString& AMessage) : EShellError(AMessage) {}
};
//---------------------------------------------------------------------------
class TFileDrop
{
private:
	TMessage FMessage;
	bool FAutoFinish;
	bool FFinished;
	__fastcall TFileDrop(const TFileDrop& AOther); // Forbidden
	TFileDrop& __fastcall operator =(const TFileDrop& AOther); // Forbidden
	void __fastcall EnsureNotFinished();
	HDROP __fastcall GetHandle();
	AnsiString __fastcall GetFile(int AIndex);
	int __fastcall GetCount();
	TPoint __fastcall GetPoint();
protected:
public:
	__fastcall TFileDrop(const TMessage& AMessage, bool AAutoFinish = true);
	__fastcall ~TFileDrop();
	void __fastcall GetFiles(TStrings* AFiles);
	void __fastcall Finish();
	__property HDROP Handle = {read=GetHandle};
	__property AnsiString Files[int AIndex] = {read=GetFile};
	__property int Count = {read=GetCount};
	__property TPoint Point = {read=GetPoint};
	__property bool AutoFinish = {read=FAutoFinish, write=FAutoFinish};
	__property bool Finished = {read=FFinished};
};
//---------------------------------------------------------------------------
}}} // End of Moochos::Moa::Shell
using namespace Moochos::Moa::Shell;
//---------------------------------------------------------------------------
#endif

