//---------------------------------------------------------------------------
#ifndef Moochos_FullGlyph_MainFormUnit_H
#define Moochos_FullGlyph_MainFormUnit_H
//---------------------------------------------------------------------------
// MainFormUnit.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <ActnList.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <Menus.hpp>
#include <StdCtrls.hpp>
#include "GlyphsMan.h"
#include "HelpMan.h"
#include "InputMan.h"
#include "SettingsMan.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace FullGlyph { namespace MainFormUnit {
//---------------------------------------------------------------------------
class EInvalidFormInput : public Exception
{
public:
	__fastcall EInvalidFormInput(const AnsiString& AMessage, TWinControl* AControl);
};
//---------------------------------------------------------------------------
}}} // End of Moochos::FullGlyph::MainFormUnit
using namespace Moochos::FullGlyph::MainFormUnit;
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TAction* GlyphsConvertFilesAc;
	TAction* GlyphsConvertDroppedFilesAc;
	TAction* GlyphsConvertAc;
	TAction* GlyphsSaveLogAsAc;
	TAction* GlyphsDeleteLogAc;
	TAction* GlyphsExitAc;
	TAction* HelpContentsAc;
	TAction* HelpAboutAc;
	TAction* InputLightColorAc;
	TAction* InputShadowColorAc;
	TAction* InputOutputDirAc;
	TActionList* ActionList1;
	TButton* Button1;
	TButton* Button2;
	TButton* Button3;
	TEdit* Edit1;
	TLabel* Label1;
	TLabel* Label2;
	TLabel* Label3;
	TLabel* Label4;
	TLabel* Label5;
	TLabel* Label6;
	TLabel* Label7;
	TMainMenu* MainMenu1;
	TMenuItem* MainMenu1Mi1;
	TMenuItem* MainMenu1Mi11;
	TMenuItem* MainMenu1Mi12;
	TMenuItem* MainMenu1Mi13;
	TMenuItem* MainMenu1Mi14;
	TMenuItem* MainMenu1Mi15;
	TMenuItem* MainMenu1Mi16;
	TMenuItem* MainMenu1Mi2;
	TMenuItem* MainMenu1Mi21;
	TMenuItem* MainMenu1Mi22;
	TMenuItem* MainMenu1Mi23;
	void __fastcall ApplicationIdle(TObject* ASender, bool& ADone);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall Edit1Exit(TObject* ASender);
	void __fastcall ActionList1Update(TBasicAction* AAction, bool& AHandled);
	void __fastcall GlyphsConvertFilesAcExecute(TObject* ASender);
	void __fastcall GlyphsConvertDroppedFilesAcExecute(TObject* ASender);
	void __fastcall GlyphsConvertAcExecute(TObject* ASender);
	void __fastcall GlyphsSaveLogAsAcExecute(TObject* ASender);
	void __fastcall GlyphsDeleteLogAcExecute(TObject* ASender);
	void __fastcall GlyphsExitAcExecute(TObject* ASender);
	void __fastcall HelpContentsAcExecute(TObject* ASender);
	void __fastcall HelpAboutAcExecute(TObject* ASender);
	void __fastcall InputLightColorAcExecute(TObject* ASender);
	void __fastcall InputShadowColorAcExecute(TObject* ASender);
	void __fastcall InputOutputDirAcExecute(TObject* ASender);
private:
	TGlyphsMan* FGlyphsMan;
	THelpMan* FHelpMan;
	TInputMan* FInputMan;
	TSettingsMan* FSettingsMan;
	TStrings* FFiles;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall ProcessParams();
	void __fastcall ValidateInputs();
	TColor __fastcall GetLightColor();
	void __fastcall SetLightColor(TColor ALightColor);
	TColor __fastcall GetShadowColor();
	void __fastcall SetShadowColor(TColor AShadowColor);
	AnsiString __fastcall GetOutputDir();
	void __fastcall SetOutputDir(AnsiString AOutputDir);
	TColor __fastcall GetColorInput(TLabel* ASampleLabel);
	void __fastcall SetColorInput(TLabel* ASampleLabel, TLabel* AValueLabel, TColor AColor);
	void __fastcall UpdateAccess();
	void __fastcall WMDropFiles(TMessage& AMessage);
protected:
public:
	virtual __fastcall TMainForm(TComponent* AOwner);
	virtual __fastcall ~TMainForm();
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_DROPFILES, TMessage, WMDropFiles)
	END_MESSAGE_MAP(TForm)
	__property TGlyphsMan* GlyphsMan = {read=FGlyphsMan};
	__property THelpMan* HelpMan = {read=FHelpMan};
	__property TInputMan* InputMan = {read=FInputMan};
	__property TSettingsMan* SettingsMan = {read=FSettingsMan};
	__property TStrings* Files = {read=FFiles};
	__property TColor LightColor = {read=GetLightColor, write=SetLightColor};
	__property TColor ShadowColor = {read=GetShadowColor, write=SetShadowColor};
	__property AnsiString OutputDir = {read=GetOutputDir, write=SetOutputDir};
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm* MainForm;
//---------------------------------------------------------------------------
#endif

