//---------------------------------------------------------------------------
// ProgressDialogUnit.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "ProgressDialogUnit.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TProgressDialog* ProgressDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::CancelButtonClick(TObject* ASender)
{
	CloseDialog();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::WMExecute(TMessage& AMessage)
{
	DoExecute();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::WMClose(TMessage& AMessage)
{
	if(!FAllowClose) {
		DoCancel();
		return;
	}
	TForm::Dispatch(&AMessage);
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::DoExecute()
{
	if(OnExecute != NULL) {
		OnExecute(this);
	}
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::DoCancel()
{
	if(OnCancel != NULL) {
		OnCancel(this);
	}
}
//---------------------------------------------------------------------------
__fastcall TProgressDialog::TProgressDialog(TComponent* AOwner)	:
	TForm(AOwner),
	FModal(false),
	FAllowClose(false),
	FOnExecute(NULL),
	FOnCancel(NULL)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TProgressDialog::~TProgressDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::Execute(bool AModal)
{
	::PostMessage(Handle, WM_EXECUTE, 0, 0);
	FModal = AModal;
	FAllowClose = false;
	if(AModal) {
		ShowModal();
	}
	else {
		Show();
	}
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::Cancel()
{
	CancelButton->Click();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::LeaveDialog()
{
	FAllowClose = true;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::CloseDialog()
{
	FAllowClose = true;
	::SendMessage(Handle, WM_CLOSE, 0, 0);
}
//---------------------------------------------------------------------------

