//---------------------------------------------------------------------------
#ifndef Moochos_FullGlyph_ProgressDialogUnit_H
#define Moochos_FullGlyph_ProgressDialogUnit_H
//---------------------------------------------------------------------------
// ProgressDialogUnit.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class TProgressDialog : public TForm
{
__published:
	TButton* CancelButton;
	TLabel* MessageLabel;
	TLabel* NoteLabel;
	TProgressBar* ProgressBar;
	void __fastcall CancelButtonClick(TObject* ASender);
public:
private:
	static const UINT WM_EXECUTE = WM_APP + 0;
	bool FModal;
	bool FAllowClose;
	TNotifyEvent FOnExecute;
	TNotifyEvent FOnCancel;
	void __fastcall WMExecute(TMessage& AMessage);
	void __fastcall WMClose(TMessage& AMessage);
	void __fastcall DoExecute();
	void __fastcall DoCancel();
protected:
public:
	virtual __fastcall TProgressDialog(TComponent* AOwner);
	virtual __fastcall ~TProgressDialog();
	void __fastcall Execute(bool AModal);
	void __fastcall Cancel();
	void __fastcall LeaveDialog();
	void __fastcall CloseDialog();
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_EXECUTE, TMessage, WMExecute)
		MESSAGE_HANDLER(WM_CLOSE, TMessage, WMClose)
	END_MESSAGE_MAP(TForm)
	__property bool Modal = {read=FModal};
	__property TNotifyEvent OnExecute = {read=FOnExecute, write=FOnExecute};
	__property TNotifyEvent OnCancel = {read=FOnCancel, write=FOnCancel};
};
//---------------------------------------------------------------------------
extern PACKAGE TProgressDialog* ProgressDialog;
//---------------------------------------------------------------------------
#endif

